Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/orografi_strato.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/orografi_strato.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/orografi_strato.F90	(revision 3605)
@@ -1819,4 +1819,5 @@
   USE mod_phys_lmdz_para
   USE mod_grid_phy_lmdz
+  USE geometry_mod
   IMPLICIT NONE
 
@@ -1832,6 +1833,6 @@
   INTEGER jk
   REAL zpr, ztop, zsigt, zpm1r
-  REAL :: pplay_glo(klon_glo, nlev)
-  REAL :: paprs_glo(klon_glo, nlev+1)
+  INTEGER :: cell,ij,nstra_tmp,nktopg_tmp
+  REAL :: current_dist, dist_min,dist_min_glo
 
   ! *       1.    SET THE VALUES OF THE PARAMETERS
@@ -1848,20 +1849,52 @@
   ! old  ZSIGT=0.85
 
-  CALL gather(pplay, pplay_glo)
-  CALL bcast(pplay_glo)
-  CALL gather(paprs, paprs_glo)
-  CALL bcast(paprs_glo)
-
-  DO jk = 1, nlev
-    zpm1r = pplay_glo(klon_glo/2+1, jk)/paprs_glo(klon_glo/2+1, 1)
-    IF (zpm1r>=zsigt) THEN
-      nktopg = jk
-    END IF
-    zpm1r = pplay_glo(klon_glo/2+1, jk)/paprs_glo(klon_glo/2+1, 1)
-    IF (zpm1r>=ztop) THEN
-      nstra = jk
-    END IF
-  END DO
-
+
+!ym Take the point at equator close to (0,0) coordinates.
+  dist_min=360
+  dist_min_glo=360.
+  cell=-1
+  DO ij=1,klon
+    current_dist=sqrt(longitude_deg(ij)**2+latitude_deg(ij)**2)
+    current_dist=current_dist*(1+(1e-10*ind_cell_glo(ij))/klon_glo) ! For point unicity
+    IF (dist_min>current_dist) THEN
+      dist_min=current_dist
+      cell=ij    
+    ENDIF  
+  ENDDO
+  
+  !PRINT *, 'SUGWD distmin cell=', dist_min,cell
+  CALL reduce_min(dist_min,dist_min_glo)
+  CALL bcast(dist_min_glo)
+  IF (dist_min/=dist_min_glo) cell=-1
+!ym in future find the point at equator close to (0,0) coordinates.
+  PRINT *, 'SUGWD distmin dist_min_glo cell=', dist_min,dist_min_glo,cell
+
+  nktopg_tmp=nktopg
+  nstra_tmp=nstra
+  
+  IF (cell/=-1) THEN
+
+    !print*,'SUGWD shape ',shape(pplay),cell+1
+
+    DO jk = 1, nlev
+      !zpm1r = pplay(cell+1, jk)/paprs(cell+1, 1)
+      zpm1r = pplay(cell, jk)/paprs(cell, 1)
+      IF (zpm1r>=zsigt) THEN
+        nktopg_tmp = jk
+      END IF
+      IF (zpm1r>=ztop) THEN
+        nstra_tmp = jk
+      END IF
+    END DO
+  ELSE
+    nktopg_tmp=0
+    nstra_tmp=0
+  ENDIF
+  
+  CALL reduce_sum(nktopg_tmp,nktopg)
+  CALL bcast(nktopg)
+  CALL reduce_sum(nstra_tmp,nstra)
+  CALL bcast(nstra)
+  
   ! inversion car dans orodrag on compte les niveaux a l'envers
   nktopg = nlev - nktopg + 1
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/pbl_surface_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/pbl_surface_mod.F90	(revision 3605)
@@ -60,4 +60,5 @@
     USE print_control_mod, ONLY: lunout
     USE ioipsl_getin_p_mod, ONLY : getin_p
+    IMPLICIT NONE
 
     INCLUDE "dimsoil.h"
@@ -288,5 +289,5 @@
     USE indice_sol_mod
     USE time_phylmdz_mod,   ONLY : day_ini,annee_ref,itau_phy
-    USE mod_grid_phy_lmdz,  ONLY : nbp_lon, nbp_lat
+    USE mod_grid_phy_lmdz,  ONLY : nbp_lon, nbp_lat, grid1dto2d_glo
     USE print_control_mod,  ONLY : prt_level,lunout
     USE ioipsl_getin_p_mod, ONLY : getin_p
@@ -861,10 +862,10 @@
           idayref = day_ini
           CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
-          CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlon,zx_lon)
+          CALL grid1dTo2d_glo(rlon,zx_lon)
           DO i = 1, nbp_lon
              zx_lon(i,1) = rlon(i+1)
              zx_lon(i,nbp_lat) = rlon(i+1)
           ENDDO
-          CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlat,zx_lat)
+          CALL grid1dTo2d_glo(rlat,zx_lat)
           CALL histbeg("sous_index",nbp_lon,zx_lon(:,1),nbp_lat,zx_lat(1,:), &
                1,nbp_lon,1,nbp_lat, &
@@ -1951,5 +1952,5 @@
                itap, dtime, jour, knon, ni, &
 !!jyg               ypplay(:,1), zgeo1/RG, ycdragh, ycdragm, yrain_f, ysnow_f, yt(:,1), yq(:,1),&
-               ypplay(:,1), zgeo1/RG, ycdragh, ycdragm, yrain_f, ysnow_f, yt1, yq1,&
+               ypplay(:,1), zgeo1(1:knon)/RG, ycdragh, ycdragm, yrain_f, ysnow_f, yt(:,1), yq(:,1),&    ! ym missing init
                AcoefH, AcoefQ, BcoefH, BcoefQ, &
                AcoefU, AcoefV, BcoefU, BcoefV, &
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/phyaqua_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/phyaqua_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/phyaqua_mod.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 MODULE phyaqua_mod
   ! Routines complementaires pour la physique planetaire.
@@ -5,5 +8,5 @@
 CONTAINS
 
-  SUBROUTINE iniaqua(nlon, iflag_phys)
+  SUBROUTINE iniaqua(nlon,year_len,iflag_phys)
 
     ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -29,5 +32,10 @@
     USE indice_sol_mod
     USE nrtype, ONLY: pi
-    USE ioipsl
+!    USE ioipsl
+    USE mod_phys_lmdz_para, ONLY: is_master
+    USE mod_phys_lmdz_transfert_para, ONLY: bcast
+    USE mod_grid_phy_lmdz
+    USE ioipsl_getin_p_mod, ONLY : getin_p
+    USE phys_cal_mod , ONLY: calend, year_len_phy => year_len 
     IMPLICIT NONE
 
@@ -36,5 +44,5 @@
     include "dimsoil.h"
 
-    INTEGER, INTENT (IN) :: nlon, iflag_phys
+    INTEGER, INTENT (IN) :: nlon, year_len, iflag_phys
     ! IM ajout latfi, lonfi
 !    REAL, INTENT (IN) :: lonfi(nlon), latfi(nlon)
@@ -57,6 +65,4 @@
     INTEGER it, unit, i, k, itap
 
-    REAL airefi, zcufi, zcvfi
-
     REAL rugos, albedo
     REAL tsurf
@@ -64,9 +70,5 @@
     REAL qsol_f
     REAL rugsrel(nlon)
-    ! real zmea(nlon),zstd(nlon),zsig(nlon)
-    ! real zgam(nlon),zthe(nlon),zpic(nlon),zval(nlon)
-    ! real rlon(nlon),rlat(nlon)
     LOGICAL alb_ocean
-    ! integer demih_pas
 
     CHARACTER *80 ans, file_forctl, file_fordat, file_start
@@ -74,23 +76,18 @@
     CHARACTER *2 cnbl
 
-    REAL phy_nat(nlon, 360)
-    REAL phy_alb(nlon, 360)
-    REAL phy_sst(nlon, 360)
-    REAL phy_bil(nlon, 360)
-    REAL phy_rug(nlon, 360)
-    REAL phy_ice(nlon, 360)
-    REAL phy_fter(nlon, 360)
-    REAL phy_foce(nlon, 360)
-    REAL phy_fsic(nlon, 360)
-    REAL phy_flic(nlon, 360)
+    REAL phy_nat(nlon, year_len)
+    REAL phy_alb(nlon, year_len)
+    REAL phy_sst(nlon, year_len)
+    REAL phy_bil(nlon, year_len)
+    REAL phy_rug(nlon, year_len)
+    REAL phy_ice(nlon, year_len)
+    REAL phy_fter(nlon, year_len)
+    REAL phy_foce(nlon, year_len)
+    REAL phy_fsic(nlon, year_len)
+    REAL phy_flic(nlon, year_len)
 
     INTEGER, SAVE :: read_climoz = 0 ! read ozone climatology
-
-    ! intermediate variables to use getin (need to be "save" to be shared by
-    ! all threads)
-    INTEGER, SAVE :: nbapp_rad_omp
-    REAL, SAVE :: co2_ppm_omp, solaire_omp
-    LOGICAL, SAVE :: alb_ocean_omp
-    REAL, SAVE :: rugos_omp
+!$OMP THREADPRIVATE(read_climoz)
+
     ! -------------------------------------------------------------------------
     ! declaration pour l'appel a phyredem
@@ -117,8 +114,10 @@
     INTEGER l, ierr, aslun
 
-!    REAL longitude, latitude
     REAL paire
 
-!    DATA latitude, longitude/48., 0./
+    ! Local
+    CHARACTER (LEN=20) :: modname='phyaqua'
+    CHARACTER (LEN=80) :: abort_message
+
 
     ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -130,4 +129,13 @@
     ! -------------------------------
 
+    !IF (calend .EQ. "earth_360d") Then
+      year_len_phy = year_len
+    !END IF
+    
+    if (year_len.ne.360) then
+      write (*,*) year_len
+      write (*,*) 'iniaqua: 360 day calendar is required !'
+      stop
+    endif
 
     type_aqua = iflag_phys/100
@@ -137,5 +145,6 @@
     IF (klon/=nlon) THEN
       WRITE (*, *) 'iniaqua: klon=', klon, ' nlon=', nlon
-      STOP 'probleme de dimensions dans iniaqua'
+      abort_message= 'probleme de dimensions dans iniaqua'
+      CALL abort_physic(modname,abort_message,1)
     END IF
     CALL phys_state_var_init(read_climoz)
@@ -148,10 +157,4 @@
     time = 0.
 
-    ! IM ajout latfi, lonfi
-!    rlatd = latfi
-!    rlond = lonfi
-!    rlat = rlatd*180./pi
-!    rlon = rlond*180./pi
-
     ! -----------------------------------------------------------------------
     ! initialisations de la physique
@@ -160,13 +163,7 @@
     day_ini = day_ref
     day_end = day_ini + ndays
-!    airefi = 1.
-!    zcufi = 1.
-!    zcvfi = 1.
-    !$OMP MASTER
-    nbapp_rad_omp = 24
-    CALL getin('nbapp_rad', nbapp_rad_omp)
-    !$OMP END MASTER
-    !$OMP BARRIER
-    nbapp_rad = nbapp_rad_omp
+
+    nbapp_rad = 24
+    CALL getin_p('nbapp_rad', nbapp_rad)
 
     ! ---------------------------------------------------------------------
@@ -175,20 +172,17 @@
     ! Initialisations des constantes
     ! Ajouter les manquants dans planete.def... (albedo etc)
-    !$OMP MASTER
-    co2_ppm_omp = 348.
-    CALL getin('co2_ppm', co2_ppm_omp)
-    solaire_omp = 1365.
-    CALL getin('solaire', solaire_omp)
+    co2_ppm = 348.
+    CALL getin_p('co2_ppm', co2_ppm)
+
+    solaire = 1365.
+    CALL getin_p('solaire', solaire)
+ 
     ! CALL getin('albedo',albedo) ! albedo is set below, depending on
     ! type_aqua
-    alb_ocean_omp = .TRUE.
-    CALL getin('alb_ocean', alb_ocean_omp)
-    !$OMP END MASTER
-    !$OMP BARRIER
-    co2_ppm = co2_ppm_omp
+    alb_ocean = .TRUE.
+    CALL getin_p('alb_ocean', alb_ocean)
+
     WRITE (*, *) 'iniaqua: co2_ppm=', co2_ppm
-    solaire = solaire_omp
     WRITE (*, *) 'iniaqua: solaire=', solaire
-    alb_ocean = alb_ocean_omp
     WRITE (*, *) 'iniaqua: alb_ocean=', alb_ocean
 
@@ -226,10 +220,6 @@
     END IF
 
-    !$OMP MASTER
-    rugos_omp = rugos
-    CALL getin('rugos', rugos_omp)
-    !$OMP END MASTER
-    !$OMP BARRIER
-    rugos = rugos_omp
+    CALL getin_p('rugos', rugos)
+
     WRITE (*, *) 'iniaqua: rugos=', rugos
     zmasq(:) = pctsrf(:, is_ter)
@@ -246,5 +236,5 @@
     ! endif !alb_ocean
 
-    DO i = 1, 360
+    DO i = 1, year_len
       ! IM Terraplanete   phy_sst(:,i) = 260.+50.*cos(rlatd(:))**2
       ! IM ajout calcul profil sst selon le cas considere (cf. FBr)
@@ -262,7 +252,12 @@
     CALL profil_sst(nlon, latitude, type_profil, phy_sst)
 
-    CALL writelim(klon, phy_nat, phy_alb, phy_sst, phy_bil, phy_rug, phy_ice, &
-      phy_fter, phy_foce, phy_flic, phy_fsic)
-
+    IF (grid_type==unstructured) THEN
+      CALL writelim_unstruct(klon, phy_nat, phy_alb, phy_sst, phy_bil, phy_rug, phy_ice, &
+                             phy_fter, phy_foce, phy_flic, phy_fsic)
+    ELSE
+      
+       CALL writelim(klon, phy_nat, phy_alb, phy_sst, phy_bil, phy_rug, phy_ice, &
+                     phy_fter, phy_foce, phy_flic, phy_fsic)
+    ENDIF
 
     ! ---------------------------------------------------------------------
@@ -339,5 +334,5 @@
     PRINT *, 'iniaqua: before phyredem'
 
-    pbl_tke(:,:,:)=1.e-8
+    pbl_tke(:,:,:) = 1.e-8 
     falb1 = albedo
     falb2 = albedo
@@ -349,5 +344,5 @@
     wake_deltaq = 0.
     wake_s = 0.
-    wake_dens = 0. 
+    wake_dens = 0.
     wake_cstar = 0.
     wake_pe = 0.
@@ -360,4 +355,29 @@
     alp_bl =0.
     treedrg(:,:,:)=0.
+
+    u10m = 0.
+    v10m = 0.
+
+    ql_ancien   = 0.
+    qs_ancien   = 0.
+    u_ancien    = 0.
+    v_ancien    = 0.
+    prw_ancien  = 0.
+    prlw_ancien = 0.
+    prsw_ancien = 0.  
+
+    ale_wake    = 0.
+    ale_bl_stat = 0.  
+
+
+!ym error : the sub surface dimension is the third not second : forgotten for iniaqua
+!    falb_dir(:,is_ter,:)=0.08; falb_dir(:,is_lic,:)=0.6
+!    falb_dir(:,is_oce,:)=0.5;  falb_dir(:,is_sic,:)=0.6
+    falb_dir(:,:,is_ter)=0.08; falb_dir(:,:,is_lic)=0.6
+    falb_dir(:,:,is_oce)=0.5;  falb_dir(:,:,is_sic)=0.6
+
+!ym falb_dif has been forgotten, initialize with defaukt value found in phyetat0 or 0 ?
+!ym probably the uninitialized value was 0 for standard (regular grid) case
+    falb_dif(:,:,:)=0
 
 
@@ -488,11 +508,14 @@
   ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-  SUBROUTINE writelim(klon, phy_nat, phy_alb, phy_sst, phy_bil, phy_rug, &
+  SUBROUTINE writelim_unstruct(klon, phy_nat, phy_alb, phy_sst, phy_bil, phy_rug, &
       phy_ice, phy_fter, phy_foce, phy_flic, phy_fsic)
 
-    USE mod_phys_lmdz_para, ONLY: is_mpi_root, is_omp_root
-    USE mod_grid_phy_lmdz, ONLY: klon_glo
-    USE mod_phys_lmdz_transfert_para, ONLY: gather
+    USE mod_phys_lmdz_para, ONLY: is_omp_master, klon_mpi
+    USE mod_phys_lmdz_transfert_para, ONLY: gather_omp
+#ifdef CPP_XIOS
+    USE xios
+#endif
     IMPLICIT NONE
+
     include "netcdf.inc"
 
@@ -509,5 +532,61 @@
     REAL, INTENT (IN) :: phy_fsic(klon, 360)
 
-    REAL :: phy_glo(klon_glo, 360) ! temporary variable, to store phy_***(:)
+    REAL :: phy_mpi(klon_mpi, 360) ! temporary variable, to store phy_***(:)
+      ! on the whole physics grid
+ 
+#ifdef CPP_XIOS
+    PRINT *, 'writelim: Ecriture du fichier limit'
+
+    CALL gather_omp(phy_foce, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('foce_limout',phy_mpi)
+
+    CALL gather_omp(phy_fsic, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('fsic_limout',phy_mpi)
+      
+    CALL gather_omp(phy_fter, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('fter_limout',phy_mpi)
+      
+    CALL gather_omp(phy_flic, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('flic_limout',phy_mpi)
+
+    CALL gather_omp(phy_sst, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('sst_limout',phy_mpi)
+
+    CALL gather_omp(phy_bil, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('bils_limout',phy_mpi)
+
+    CALL gather_omp(phy_alb, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('alb_limout',phy_mpi)
+
+    CALL gather_omp(phy_rug, phy_mpi)
+    IF (is_omp_master) CALL xios_send_field('rug_limout',phy_mpi)
+#endif
+  END SUBROUTINE writelim_unstruct
+
+
+
+  SUBROUTINE writelim(klon, phy_nat, phy_alb, phy_sst, phy_bil, phy_rug, &
+      phy_ice, phy_fter, phy_foce, phy_flic, phy_fsic)
+
+    USE mod_phys_lmdz_para, ONLY: is_master
+    USE mod_grid_phy_lmdz, ONLY: klon_glo
+    USE mod_phys_lmdz_transfert_para, ONLY: gather
+    USE phys_cal_mod, ONLY: year_len
+    IMPLICIT NONE
+    include "netcdf.inc"
+
+    INTEGER, INTENT (IN) :: klon
+    REAL, INTENT (IN) :: phy_nat(klon, year_len)
+    REAL, INTENT (IN) :: phy_alb(klon, year_len)
+    REAL, INTENT (IN) :: phy_sst(klon, year_len)
+    REAL, INTENT (IN) :: phy_bil(klon, year_len)
+    REAL, INTENT (IN) :: phy_rug(klon, year_len)
+    REAL, INTENT (IN) :: phy_ice(klon, year_len)
+    REAL, INTENT (IN) :: phy_fter(klon, year_len)
+    REAL, INTENT (IN) :: phy_foce(klon, year_len)
+    REAL, INTENT (IN) :: phy_flic(klon, year_len)
+    REAL, INTENT (IN) :: phy_fsic(klon, year_len)
+
+    REAL :: phy_glo(klon_glo, year_len) ! temporary variable, to store phy_***(:)
       ! on the whole physics grid
     INTEGER :: k
@@ -522,5 +601,5 @@
     INTEGER id_fter, id_foce, id_fsic, id_flic
 
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 
       PRINT *, 'writelim: Ecriture du fichier limit'
@@ -615,5 +694,5 @@
 
       ! write the 'times'
-      DO k = 1, 360
+      DO k = 1, year_len
 #ifdef NC_DOUBLE
         ierr = nf_put_var1_double(nid, id_tim, k, dble(k))
@@ -627,10 +706,10 @@
       END DO
 
-    END IF ! of if (is_mpi_root.and.is_omp_root)
+    END IF ! of if (is_master)
 
     ! write the fields, after having collected them on master
 
     CALL gather(phy_nat, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_nat, phy_glo)
@@ -645,5 +724,5 @@
 
     CALL gather(phy_sst, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_sst, phy_glo)
@@ -658,5 +737,5 @@
 
     CALL gather(phy_bil, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_bils, phy_glo)
@@ -671,5 +750,5 @@
 
     CALL gather(phy_alb, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_alb, phy_glo)
@@ -684,5 +763,5 @@
 
     CALL gather(phy_rug, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_rug, phy_glo)
@@ -697,5 +776,5 @@
 
     CALL gather(phy_fter, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_fter, phy_glo)
@@ -710,5 +789,5 @@
 
     CALL gather(phy_foce, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_foce, phy_glo)
@@ -723,5 +802,5 @@
 
     CALL gather(phy_fsic, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_fsic, phy_glo)
@@ -736,5 +815,5 @@
 
     CALL gather(phy_flic, phy_glo)
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 #ifdef NC_DOUBLE
       ierr = nf_put_var_double(nid, id_flic, phy_glo)
@@ -749,5 +828,5 @@
 
     ! close file:
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
       ierr = nf_close(nid)
     END IF
@@ -759,16 +838,22 @@
   SUBROUTINE profil_sst(nlon, rlatd, type_profil, phy_sst)
     USE dimphy
+    USE phys_cal_mod , ONLY: year_len
     IMPLICIT NONE
 
     INTEGER nlon, type_profil, i, k, j
-    REAL :: rlatd(nlon), phy_sst(nlon, 360)
+    REAL :: rlatd(nlon), phy_sst(nlon, year_len)
     INTEGER imn, imx, amn, amx, kmn, kmx
     INTEGER p, pplus, nlat_max
     PARAMETER (nlat_max=72)
     REAL x_anom_sst(nlat_max)
-
-    IF (klon/=nlon) STOP 'probleme de dimensions dans iniaqua'
+    CHARACTER (LEN=20) :: modname='profil_sst'
+    CHARACTER (LEN=80) :: abort_message
+
+    IF (klon/=nlon) THEN
+       abort_message='probleme de dimensions dans profil_sst'
+       CALL abort_physic(modname,abort_message,1)
+    ENDIF
     WRITE (*, *) ' profil_sst: type_profil=', type_profil
-    DO i = 1, 360
+    DO i = 1, year_len
       ! phy_sst(:,i) = 260.+50.*cos(rlatd(:))**2
 
@@ -963,5 +1048,5 @@
     imx = 1
     kmx = 1
-    DO k = 1, 360
+    DO k = 1, year_len
       DO i = 2, nlon
         IF (phy_sst(i,k)<amn) THEN
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/phyetat0.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/phyetat0.F90	(revision 3605)
@@ -9,5 +9,5 @@
   USE pbl_surface_mod,  ONLY : pbl_surface_init
   USE surface_data,     ONLY : type_ocean, version_ocean
-  USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, dtime, &
+  USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, phys_tstep, &
        qsol, fevap, z0m, z0h, agesno, &
        du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
@@ -111,10 +111,12 @@
   IF (carbon_cycle_tr .OR. carbon_cycle_cpl) THEN
      co2_ppm = tab_cntrl(3)
-     RCO2    = co2_ppm * 1.0e-06  * 44.011/28.97 
+     RCO2    = co2_ppm * 1.0e-06 * RMCO2 / RMD
      ! ELSE : keep value from .def
-  END IF
-
-  ! co2_ppm0 : initial value of atmospheric CO2 (from create_etat0_limit.e .def)
-  co2_ppm0   = tab_cntrl(16)
+  ENDIF
+
+! co2_ppm0 : initial value of atmospheric CO2 (from create_etat0_limit.e .def)
+! co2_ppm0   = tab_cntrl(16)
+! initial value for interactive CO2 run when there is no tracer field for CO2 in restart
+  co2_ppm0=284.32
 
   solaire_etat0      = tab_cntrl(4)
@@ -122,10 +124,10 @@
   tab_cntrl(6)=nbapp_rad
 
-  if (iflag_cycle_diurne.GE.1) tab_cntrl( 7) = iflag_cycle_diurne
-  if (soil_model) tab_cntrl( 8) =1.
-  if (new_oliq) tab_cntrl( 9) =1.
-  if (ok_orodr) tab_cntrl(10) =1.
-  if (ok_orolf) tab_cntrl(11) =1.
-  if (ok_limitvrai) tab_cntrl(12) =1.
+  IF (iflag_cycle_diurne.GE.1) tab_cntrl( 7) = iflag_cycle_diurne
+  IF (soil_model) tab_cntrl( 8) =1.
+  IF (new_oliq) tab_cntrl( 9) =1.
+  IF (ok_orodr) tab_cntrl(10) =1.
+  IF (ok_orolf) tab_cntrl(11) =1.
+  IF (ok_limitvrai) tab_cntrl(12) =1.
 
   itau_phy = tab_cntrl(15)
@@ -164,14 +166,18 @@
   DO i=1,klon
     IF (ABS(lon_startphy(i)-longitude_deg(i))>=1) THEN
-      WRITE(*,*) "phyetat0: Error! Longitude discrepancy wrt startphy file:",&
-                 " i=",i," lon_startphy(i)=",lon_startphy(i),&
-                 " longitude_deg(i)=",longitude_deg(i)
-      ! This is presumably serious enough to abort run
-      CALL abort_physic("phyetat0","discrepancy in longitudes!",1)
+      IF (ABS(360-ABS(lon_startphy(i)-longitude_deg(i)))>=1) THEN
+        WRITE(*,*) "phyetat0: Error! Longitude discrepancy wrt startphy file:",&
+                   " i=",i," lon_startphy(i)=",lon_startphy(i),&
+                   " longitude_deg(i)=",longitude_deg(i)
+        ! This is presumably serious enough to abort run
+        CALL abort_physic("phyetat0","discrepancy in longitudes!",1)
+      ENDIF
     ENDIF
-    IF (ABS(lon_startphy(i)-longitude_deg(i))>=0.0001) THEN
-      WRITE(*,*) "phyetat0: Warning! Longitude discrepancy wrt startphy file:",&
-                 " i=",i," lon_startphy(i)=",lon_startphy(i),&
-                 " longitude_deg(i)=",longitude_deg(i)
+    IF (ABS(lon_startphy(i)-longitude_deg(i))>=1) THEN
+      IF (ABS(360-ABS(lon_startphy(i)-longitude_deg(i))) > 0.0001) THEN
+        WRITE(*,*) "phyetat0: Warning! Longitude discrepancy wrt startphy file:",&
+                   " i=",i," lon_startphy(i)=",lon_startphy(i),&
+                   " longitude_deg(i)=",longitude_deg(i)
+      ENDIF 
     ENDIF
   ENDDO
@@ -223,5 +229,5 @@
         zmasq(i) = fractint(i)
      ENDIF
-  END DO
+  ENDDO
   fractint (1 : klon) =  pctsrf(1 : klon, is_oce)  &
        + pctsrf(1 : klon, is_sic)
@@ -234,5 +240,5 @@
         zmasq(i) = 1. - fractint(i)
      ENDIF
-  END DO
+  ENDDO
 
 !===================================================================
@@ -359,13 +365,13 @@
   !          dummy values (as is the case when generated by ce0l,
   !          or by iniaqua)
-  if ( (maxval(q_ancien).eq.minval(q_ancien))       .or. &
-       (maxval(ql_ancien).eq.minval(ql_ancien))     .or. &
-       (maxval(qs_ancien).eq.minval(qs_ancien))     .or. &
-       (maxval(prw_ancien).eq.minval(prw_ancien))   .or. &
-       (maxval(prlw_ancien).eq.minval(prlw_ancien)) .or. &
-       (maxval(prsw_ancien).eq.minval(prsw_ancien)) .or. &
-       (maxval(t_ancien).eq.minval(t_ancien)) ) then
+  IF ( (maxval(q_ancien).EQ.minval(q_ancien))       .OR. &
+       (maxval(ql_ancien).EQ.minval(ql_ancien))     .OR. &
+       (maxval(qs_ancien).EQ.minval(qs_ancien))     .OR. &
+       (maxval(prw_ancien).EQ.minval(prw_ancien))   .OR. &
+       (maxval(prlw_ancien).EQ.minval(prlw_ancien)) .OR. &
+       (maxval(prsw_ancien).EQ.minval(prsw_ancien)) .OR. &
+       (maxval(t_ancien).EQ.minval(t_ancien)) ) THEN
     ancien_ok=.false.
-  endif
+  ENDIF
 
   found=phyetat0_get(klev,clwcon,"CLWCON","CLWCON",0.)
@@ -434,5 +440,5 @@
         found=phyetat0_get(1,trs(:,it),"trs_"//tname(iiq), &
               "Surf trac"//tname(iiq),0.)
-     END DO
+     ENDDO
      CALL traclmdz_from_restart(trs)
   ENDIF
@@ -444,6 +450,6 @@
         IF (ierr /= 0) CALL abort_physic('phyetat0', 'pb allocation co2_send', 1)
         found=phyetat0_get(1,co2_send,"co2_send","co2 send",co2_ppm)
-     END IF
-  END IF
+     ENDIF
+  ENDIF
 
 !===========================================
@@ -452,7 +458,7 @@
 
 !  ondes de gravite non orographiques
-  if (ok_gwd_rando) found = &
+  IF (ok_gwd_rando) found = &
        phyetat0_get(klev,du_gwd_rando,"du_gwd_rando","du_gwd_rando",0.)
-  IF (.not. ok_hines .and. ok_gwd_rando) found &
+  IF (.NOT. ok_hines .AND. ok_gwd_rando) found &
        = phyetat0_get(klev,du_gwd_front,"du_gwd_front","du_gwd_front",0.)
 
@@ -473,16 +479,16 @@
 
   IF ( type_ocean == 'slab' ) THEN
-      CALL ocean_slab_init(dtime, pctsrf)
+      CALL ocean_slab_init(phys_tstep, pctsrf)
       IF (nslay.EQ.1) THEN
         found=phyetat0_get(1,tslab,"tslab01","tslab",0.)
         IF (.NOT. found) THEN
             found=phyetat0_get(1,tslab,"tslab","tslab",0.)
-        END IF
+        ENDIF
       ELSE
           DO i=1,nslay
             WRITE(str2,'(i2.2)') i
             found=phyetat0_get(1,tslab(:,i),"tslab"//str2,"tslab",0.)  
-          END DO
-      END IF
+          ENDDO
+      ENDIF
       IF (.NOT. found) THEN 
           PRINT*, "phyetat0: Le champ <tslab> est absent"
@@ -490,6 +496,6 @@
           DO i=1,nslay
               tslab(:,i)=MAX(ftsol(:,is_oce),271.35)
-          END DO
-      END IF 
+          ENDDO
+      ENDIF 
 
       ! Sea ice variables
@@ -500,5 +506,5 @@
               PRINT*, "Initialisation a tsol_sic"
                   tice(:)=ftsol(:,is_sic)
-          END IF 
+          ENDIF 
           found=phyetat0_get(1,seaice,"seaice","seaice",0.)
           IF (.NOT. found) THEN
@@ -508,8 +514,8 @@
               WHERE (pctsrf(:,is_sic).GT.EPSFRA)
                   seaice=917.
-              END WHERE
-          END IF
-      END IF !sea ice INT
-  END IF ! Slab        
+              ENDWHERE
+          ENDIF
+      ENDIF !sea ice INT
+  ENDIF ! Slab        
 
   ! on ferme le fichier
@@ -522,8 +528,8 @@
   ! Initialize module ocean_cpl_mod for the case of coupled ocean
   IF ( type_ocean == 'couple' ) THEN
-     CALL ocean_cpl_init(dtime, longitude_deg, latitude_deg)
-  ENDIF
-
-  CALL init_iophy_new(latitude_deg, longitude_deg)
+     CALL ocean_cpl_init(phys_tstep, longitude_deg, latitude_deg)
+  ENDIF
+
+!  CALL init_iophy_new(latitude_deg, longitude_deg)
 
   ! Initilialize module fonte_neige_mod      
